import splunk.rest

class PDFGenHandlerIsAvailable(splunk.rest.BaseRestHandler):
    def handle_GET(self):
        viewId = None
        owner = None
        namespace = None

        if 'viewId' in self.args:
            viewId = self.args['viewId']
        if 'owner' in self.args:
            owner = self.args['owner']
        if 'namespace' in self.args:
            namespace = self.args['namespace']

        # TODO: refactor this into a shared function used here and in sendemail.py
        pdfService = "none"
        if viewId is None:
            pdfService = "pdfgen"
        else:
            import splunk.entity as entity
            import lxml.etree as et

            # this is either a simple dashboard, simple form, or advanced XML view
            # get the entity of the view and then check the root node
            entityId = entity.buildEndpoint('data/ui/views', viewId, namespace=namespace, owner=owner)
            viewEntity = entity.getEntity('data/ui/views', None, sessionKey=self.sessionKey, uri=entityId)
            data = viewEntity['eai:data']
            if data:
                root = et.fromstring(unicode(data).encode('utf-8'))
                if root.tag == "dashboard":
                    pdfService = "pdfgen"
                else:
                    pdfService = "deprecated"

        self.response.setStatus(200)
        self.response.write(pdfService)

